/* ANSI-C code produced by gperf version 2.7.2 */
/* Command-line: gperf -l -E -L ANSI-C -I -H string_hash -N sieve_string -C -o -k '1,$' -t string.gperf  */
struct string;
#include <string.h>
/* maximum key range = 34, duplicates = 0 */

#ifdef __GNUC__
__inline
#else
#ifdef __cplusplus
inline
#endif
#endif
static unsigned int
string_hash (register const char *str, register unsigned int len)
{
  static const unsigned char asso_values[] =
    {
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38,  0,
      38, 10,  5, 15, 38,  0, 38, 38, 10, 38,
      25,  0, 10, 20,  0,  0,  0, 38,  0, 38,
       0,  0, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38, 38, 38, 38, 38,
      38, 38, 38, 38, 38, 38
    };
  return len + asso_values[(unsigned char)str[len - 1]] + asso_values[(unsigned char)str[0]];
}

#ifdef __GNUC__
__inline
#endif
const struct string *
sieve_string (register const char *str, register unsigned int len)
{
  enum
    {
      TOTAL_KEYWORDS = 21,
      MIN_WORD_LENGTH = 2,
      MAX_WORD_LENGTH = 26,
      MIN_HASH_VALUE = 4,
      MAX_HASH_VALUE = 37
    };

  static const unsigned char lengthtable[] =
    {
       0,  0,  0,  0,  4,  5,  6,  7,  8,  9, 10,  0,  2,  8,
       0, 15,  0,  2, 18,  0, 10,  0,  2,  0,  0, 15, 26,  2,
       8,  0,  0,  0,  2,  0,  0,  0, 26,  2
    };
  static const struct string wordlist[] =
    {
      {""}, {""}, {""}, {""},
      {"copy",                SIEVE_STRING_COPY},
      {"regex",               SIEVE_STRING_REGEX},
      {"reject",              SIEVE_STRING_REJECT},
      {"i;octet",	     SIEVE_STRING_I_OCTET},
      {"spamtest",            SIEVE_STRING_SPAMTEST},
      {"virustest",           SIEVE_STRING_VIRUSTEST},
      {"subaddress",          SIEVE_STRING_SUBADDRESS},
      {""},
      {"lt",                  SIEVE_STRING_LT},
      {"fileinto",            SIEVE_STRING_FILEINTO},
      {""},
      {"i;ascii-numeric",     SIEVE_STRING_I_ASCII_NUMERIC},
      {""},
      {"gt",		     SIEVE_STRING_GT},
      {"comparator-i;octet",  SIEVE_STRING_COMPARATOR_I_OCTET},
      {""},
      {"relational",          SIEVE_STRING_RELATIONAL},
      {""},
      {"le",                  SIEVE_STRING_LE},
      {""}, {""},
      {"i;ascii-casemap",     SIEVE_STRING_I_ASCII_CASEMAP},
      {"comparator-i;ascii-numeric",  SIEVE_STRING_COMPARATOR_I_ASCII_NUMERIC},
      {"ge",                  SIEVE_STRING_GE},
      {"envelope",            SIEVE_STRING_ENVELOPE},
      {""}, {""}, {""},
      {"eq",                  SIEVE_STRING_EQ},
      {""}, {""}, {""},
      {"comparator-i;ascii-casemap",  SIEVE_STRING_COMPARATOR_I_ASCII_CASEMAP},
      {"ne",                  SIEVE_STRING_NE}
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = string_hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= 0)
        if (len == lengthtable[key])
          {
            register const char *s = wordlist[key].name;

            if (*str == *s && !memcmp (str + 1, s + 1, len - 1))
              return &wordlist[key];
          }
    }
  return 0;
}
